Overview | Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang
Class System

    java.lang.Object
      java.lang.System

    public final class System

extends Object

The `System` class contains several useful class fields and methods. It cannot be instantiated.

Among the facilities provided by the `System` class are standard input, standard output, and error output streams; access to externally defined "properties"; a means of loading files and libraries; and a utility method for quickly copying a portion of an array.

Since:
  JDK1.0
Version:
  1.125, 12/03/01
Author:
  Arthur van Hoff, Helge Böhme (JControl)
Available on JControl Devices:

  lib

Field Summary
`static ConsoleOutputStream` | `err` The "standard" error output stream.
`static ConsoleInputStream` | `in` The "standard" input stream.
`static ConsoleOutputStream` | `out` The "standard" output stream.

Constructor Summary
`System()`

Method Summary
`static void` | `arraycopy(Object src, int srcPos, Object dest, int destPos, int length)` Copies an array from the specified source array, beginning at the specified position, to the specified position of the destination array.
`static void` | `setErr(ConsoleOutputStream newErr)` Reassigns the "standard" error output stream.
`static void` | `setIn(ConsoleInputStream newIn)` Reassigns the "standard" input stream.
`static void` | `setOut(ConsoleOutputStream newOut)` Reassigns the "standard" output stream.

Methods inherited from class java.lang.Object
`clone, equals, notifyAll, wait`

Field Detail

### err

    public static ConsoleOutputStream err

  The "standard" error output stream. This stream is already open and ready to accept output data.

  Typically this stream corresponds to display output or another output destination specified by the host environment or user. By convention, this output stream is used to display error messages or other information that should come to the immediate attention of a user even if the principal output stream, the value of the variable `out`, has been redirected to a file or other destination that is typically not continuously monitored.

  See Also:
    `ConsoleOutputStream`

### in

    public static ConsoleInputStream in

  The "standard" input stream. This stream is already open and ready to supply input data. Typically this stream corresponds to keyboard input or another input source specified by the host environment or user.

  See Also:
    `ConsoleInputStream`

### out

    public static ConsoleOutputStream out

  The "standard" output stream. This stream is already open and ready to accept output data. Typically this stream corresponds to display output or another output destination specified by the host environment or user.

  For simple stand-alone Java applications, a typical way to write a line of output data is:

  >          System.out.println(data)

  See the `println` methods in class `PrintStream`.

  See Also:
    `ConsoleOutputStream`

Constructor Detail

### System

    public System()

Method Detail

### arraycopy

    public static void arraycopy(Object src,
                                 int srcPos,
                                 Object dest,
                                 int destPos,
                                 int length)

  Copies an array from the specified source array, beginning at the specified position, to the specified position of the destination array. A subsequence of array components are copied from the source array referenced by `src` to the destination array referenced by `dest`. The number of components copied is equal to the `length` argument. The components at positions `srcPos` through `srcPos+length-1` in the source array are copied into positions `destPos` through `destPos+length-1`, respectively, of the destination array.

  If the `src` and `dest` arguments refer to the same array object, then the copying is performed as if the components at positions `srcPos` through `srcPos+length-1` were first copied to a temporary array with `length` components and then the contents of the temporary array were copied into positions `destPos` through `destPos+length-1` of the destination array.

  If `dest` is `null`, then a `NullPointerException` is thrown.

  If `src` is `null`, then a `NullPointerException` is thrown and the destination array is not modified.

  Otherwise, if any of the following is true, an `ArrayStoreException` is thrown and the destination is not modified:

  - The `src` argument refers to an object that is not an array.
  - The `dest` argument refers to an object that is not an array.
  - The `src` argument and `dest` argument refer to arrays whose component types are different primitive types.
  - The `src` argument refers to an array with a primitive component type and the `dest` argument refers to an array with a reference component type.
  - The `src` argument refers to an array with a reference component type and the `dest` argument refers to an array with a primitive component type.

  Otherwise, if any of the following is true, an `IndexOutOfBoundsException` is thrown and the destination is not modified:

  - The `srcPos` argument is negative.
  - The `destPos` argument is negative.
  - The `length` argument is negative.
  - `srcPos+length` is greater than `src.length`, the length of the source array.
  - `destPos+length` is greater than `dest.length`, the length of the destination array.

  Otherwise, if any actual component of the source array from position `srcPos` through `srcPos+length-1` cannot be converted to the component type of the destination array by assignment conversion, an `ArrayStoreException` is thrown. In this case, let k be the smallest nonnegative integer less than length such that `src[srcPos+`k`]` cannot be converted to the component type of the destination array; when the exception is thrown, source array components from positions `srcPos` through `srcPos+`k`-1` will already have been copied to destination array positions `destPos` through `destPos+`k`-1` and no other positions of the destination array will have been modified. (Because of the restrictions already itemized, this paragraph effectively applies only to the situation where both arrays have component types that are reference types.)

  A wrapper for `Management.arraycopy(Object src, int srcPos, Object dest, int destPos, int length)`.

  Parameters:
    `src` - the source array.
    `srcPos` - starting position in the source array.
    `dest` - the destination array.
    `destPos` - starting position in the destination data.
    `length` - the number of array elements to be copied.
  Throws:
    `java.lang.IndexOutOfBoundsException` - if copying would cause access of data outside array bounds.
    `java.lang.ArrayStoreException` - if an element in the `src` array could not be stored into the `dest` array because of a type mismatch.
    `java.lang.NullPointerException` - if either `src` or `dest` is `null`.

### setErr

    public static void setErr(ConsoleOutputStream newErr)

  Reassigns the "standard" error output stream.

  First, if there is a security manager, its `checkPermission` method is called with a `RuntimePermission("setIO")` permission to see if it's ok to reassign the "standard" error output stream.

  Parameters:
    `newErr` - the new standard error output stream.
  Throws:
    `java.lang.SecurityException` - if a security manager exists and its `checkPermission` method doesn't allow reassigning of the standard error output stream.
  Since:
    JDK1.1
  See Also:
    `SecurityManager.checkPermission(java.security.Permission)`, `RuntimePermission`

### setIn

    public static void setIn(ConsoleInputStream newIn)

  Reassigns the "standard" input stream.

  First, if there is a security manager, its `checkPermission` method is called with a `RuntimePermission("setIO")` permission to see if it's ok to reassign the "standard" input stream.

  Parameters:
    `newIn` - the new standard input stream.
  Throws:
    `java.lang.SecurityException` - if a security manager exists and its `checkPermission` method doesn't allow reassigning of the standard input stream.
  Since:
    JDK1.1
  See Also:
    `SecurityManager.checkPermission(java.security.Permission)`, `RuntimePermission`

### setOut

    public static void setOut(ConsoleOutputStream newOut)

  Reassigns the "standard" output stream.

  First, if there is a security manager, its `checkPermission` method is called with a `RuntimePermission("setIO")` permission to see if it's ok to reassign the "standard" output stream.

  Parameters:
    `newOut` - the new standard output stream
  Throws:
    `java.lang.SecurityException` - if a security manager exists and its `checkPermission` method doesn't allow reassigning of the standard output stream.
  Since:
    JDK1.1
  See Also:
    `SecurityManager.checkPermission(java.security.Permission)`, `RuntimePermission`

Overview | Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD